#jinja2: trim_blocks: True, lstrip_blocks: True
{{ ansible_managed | comment }}
# http://prometheus.io/docs/operating/configuration/

global:
  resolve_timeout: 5m

# The directory from which notification templates are read.
templates: []

route:
  receiver: 'slack-notifications-default'
  group_wait: 10s
  group_interval: 10s
  repeat_interval: 1h
  group_by: ['alertname', 'datacentre']
  routes:
  - receiver: 'slack-notifications-match'
    matchers:
      - namespace =~ {{ alertmanager_match_regex }}
{% if alertmanager_no_match_regex %}
      - namespace !~ {{ alertmanager_no_match_regex }}
{% endif %}
      - alertname !~ {{ alertmanager_global_health_regex }}
  - receiver: 'slack-notifications-global-health'
    repeat_interval: 12h
    group_by: ['datacentre']
    matchers:
      - alertname =~ {{ alertmanager_global_health_regex }}
{% if alertmanager_global_health_oncall_webhook_url is not none %}
  - receiver: 'grafana-oncall'
    repeat_interval: 1h
    group_by: [alertname, datacenter, app]
{% endif %}
{% if alertmanager_monitoring_slack_api_url is not none %}
  - receiver: 'slack-notifications-monitoring'
    matchers:
      - alertname =~ "MonitoringDown"
    group_wait: 10s
    group_interval: 10s
    repeat_interval: 1h
    group_by: ['alertname', 'datacentre']
{% endif %}

{% if alerts_inhibit_rules != [] %}
inhibit_rules:
{{ alerts_inhibit_rules | to_nice_yaml(indent=2) | indent(2,False) }}
{% endif %}

receivers:
- name: 'slack-notifications-default'
  slack_configs:
  - api_url: {{ alertmanager_default_slack_api_url }}
    channel: {{ alertmanager_default_slack_channel }}
    text: "<!channel> \nAlert: <{{ '{{' }} if .CommonAnnotations.runbook_url {{ '}}' }}{{ '{{' }} .CommonAnnotations.runbook_url {{ '}}' }}|{{ '{{' }} end {{ '}}' }}{{ '{{' }} .GroupLabels.alertname {{ '}}' }}> {{ '{{' }} if .CommonAnnotations.namespace {{ '}}' }} \nNamespace: <https://k8s.stfc.skao.int/kibana/app/logs/stream?flyoutOptions=(flyoutId:!n,flyoutVisibility:hidden,surroundingLogsId:!n)&logFilter=(expression:%27kubernetes.namespace%20:%20{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}%27,kind:kuery)&logPosition=(end:now,,start:now-1d,streamLive:!f)|{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}> {{ '{{' }} end {{ '}}' }}  {{ '{{' }} if .CommonAnnotations.summary {{ '}}' }}\nSummary: {{ '{{' }} .CommonAnnotations.summary {{ '}}' }} {{ '{{' }} end {{ '}}' }} {{ '{{' }} if .CommonAnnotations.message {{ '}}' }}\nMessage: {{ '{{' }} .CommonAnnotations.message {{ '}}' }} {{ '{{' }} end {{ '}}' }}\nSee: <{{ alertmanager_alert_prometheus_url }}/alerts|Alerts> and all <{{ alertmanager_alert_alertmanager_url }}/#/alerts?receiver=slack-notifications-default|Slack Notifications>\n\n{{ '{{' }} if gt (len .Alerts) 1 {{ '}}' }}Details:\n---\n{{ '{{' }} range .Alerts {{ '}}' }}{{ '{{' }} range $key, $value := .Labels {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}{{ '{{' }} range $key, $value := .Annotations {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}\n---\n{{ '{{' }} end {{ '}}' }}{{ '{{' }}  end {{ '}}' }}"
{% if alertmanager_default_slack_title_link is not none %}
    title_link: {{ alertmanager_default_slack_title_link }}
{% endif %}

- name: 'slack-notifications-match'
  slack_configs:
  - api_url: {{ alertmanager_match_slack_api_url }}
    channel: {{ alertmanager_match_slack_channel }}
    text: "<!channel> \nAlert: <{{ '{{' }} if .CommonAnnotations.runbook_url {{ '}}' }}{{ '{{' }} .CommonAnnotations.runbook_url {{ '}}' }}|{{ '{{' }} end {{ '}}' }}{{ '{{' }} .GroupLabels.alertname {{ '}}' }}> {{ '{{' }} if .CommonAnnotations.namespace {{ '}}' }} \nNamespace: <https://k8s.stfc.skao.int/kibana/app/logs/stream?flyoutOptions=(flyoutId:!n,flyoutVisibility:hidden,surroundingLogsId:!n)&logFilter=(expression:%27kubernetes.namespace%20:%20{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}%27,kind:kuery)&logPosition=(end:now,,start:now-1d,streamLive:!f)|{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}> {{ '{{' }} end {{ '}}' }}  {{ '{{' }} if .CommonAnnotations.summary {{ '}}' }}\nSummary: {{ '{{' }} .CommonAnnotations.summary {{ '}}' }} {{ '{{' }} end {{ '}}' }} {{ '{{' }} if .CommonAnnotations.message {{ '}}' }}\nMessage: {{ '{{' }} .CommonAnnotations.message {{ '}}' }} {{ '{{' }} end {{ '}}' }}\nSee: <{{ alertmanager_alert_prometheus_url }}/alerts|Alerts> and all <{{ alertmanager_alert_alertmanager_url }}/#/alerts?receiver=slack-notifications-match|Slack Notifications>\n\n{{ '{{' }} if gt (len .Alerts) 1 {{ '}}' }}Details:\n---\n{{ '{{' }} range .Alerts {{ '}}' }}{{ '{{' }} range $key, $value := .Labels {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}{{ '{{' }} range $key, $value := .Annotations {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}\n---\n{{ '{{' }} end {{ '}}' }}{{ '{{' }}  end {{ '}}' }}"
{% if alertmanager_match_slack_title_link is not none %}
    title_link: {{ alertmanager_match_slack_title_link }}
{% endif %}

- name: 'slack-notifications-global-health'
  slack_configs:
  - api_url: {{ alertmanager_global_health_slack_api_url }}
    channel: {{ alertmanager_global_health_slack_channel }}
    send_resolved: true
    text: "<!channel> \n*Health Problem* {{ '{{' }} $num_alerts := len .Alerts {{ '}}' }}{{ '{{' }} range .Alerts {{ '}}' }} \n*Alert:* {{ '{{' }} .Labels.alertname {{ '}}' }} {{ '{{' }} if ne .EndsAt.IsZero true {{ '}}' }} *[RESOLVED]* {{ '{{' }} end {{ '}}' }} \n*Summary*: {{ '{{' }} .Annotations.summary {{ '}}' }} \n*Start Time:* {{ '{{' }} .StartsAt {{ '}}' }}{{ '{{' }} if ne .EndsAt.IsZero true {{ '}}' }}\n*End Time:* {{ '{{' }} .EndsAt {{ '}}' }}{{ '{{' }} end {{ '}}' }}{{ '{{' }} if gt ($num_alerts) 1 {{ '}}' }} \n------------------------------{{ '{{' }} end {{ '}}' }}{{ '{{' }} end {{ '}}' }}"
{% if alertmanager_global_health_slack_title_link is not none %}
    title_link: {{ alertmanager_global_health_slack_title_link }}
{% endif %}

{% if alertmanager_global_health_oncall_webhook_url is not none %}
- name: 'grafana-oncall'
  webhook_configs:
  - url: {{ alertmanager_global_health_oncall_webhook_url }}
    send_resolved: true
{% endif %}

{% if alertmanager_monitoring_slack_api_url is not none %}
- name: 'slack-notifications-monitoring'
  slack_configs:
  - api_url: {{ alertmanager_monitoring_slack_api_url }}
    channel: {{ alertmanager_monitoring_slack_channel }}
    text: "<!channel> \nAlert: <{{ '{{' }} if .CommonAnnotations.runbook_url {{ '}}' }}{{ '{{' }} .CommonAnnotations.runbook_url {{ '}}' }}|{{ '{{' }} end {{ '}}' }}{{ '{{' }} .GroupLabels.alertname {{ '}}' }}> {{ '{{' }} if .CommonAnnotations.namespace {{ '}}' }} \nNamespace: <https://k8s.stfc.skao.int/kibana/app/logs/stream?flyoutOptions=(flyoutId:!n,flyoutVisibility:hidden,surroundingLogsId:!n)&logFilter=(expression:%27kubernetes.namespace%20:%20{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}%27,kind:kuery)&logPosition=(end:now,,start:now-1d,streamLive:!f)|{{ '{{' }} .CommonAnnotations.namespace {{ '}}' }}> {{ '{{' }} end {{ '}}' }}  {{ '{{' }} if .CommonAnnotations.summary {{ '}}' }}\nSummary: {{ '{{' }} .CommonAnnotations.summary {{ '}}' }} {{ '{{' }} end {{ '}}' }} {{ '{{' }} if .CommonAnnotations.message {{ '}}' }}\nMessage: {{ '{{' }} .CommonAnnotations.message {{ '}}' }} {{ '{{' }} end {{ '}}' }}\nSee: <{{ alertmanager_alert_prometheus_url }}/alerts|Alerts> and all <{{ alertmanager_alert_alertmanager_url }}/#/alerts?receiver=slack-notifications-specific|Slack Notifications>\n\n{{ '{{' }} if gt (len .Alerts) 1 {{ '}}' }}Details:\n---\n{{ '{{' }} range .Alerts {{ '}}' }}{{ '{{' }} range $key, $value := .Labels {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}{{ '{{' }} range $key, $value := .Annotations {{ '}}' }}{{ '{{' }} $key {{ '}}' }}: {{ '{{' }} $value {{ '}}' }}\n{{ '{{' }} end {{ '}}' }}\n---\n{{ '{{' }} end {{ '}}' }}{{ '{{' }}  end {{ '}}' }}"
{% if alertmanager_monitoring_slack_title_link is not none %}
    title_link: {{ alertmanager_monitoring_slack_title_link }}
{% endif %}
{% endif %}